Index: trunk/source/geometry/solids/CSG/src/G4Sphere.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Sphere.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Sphere.cc	(revision 1228)
@@ -2377,15 +2048,13 @@
               }
             }
-            // s = -0.5*dist2STheta/t2;
-
             stheta    = -0.5*dist2STheta/t2;
             sidetheta = kSTheta;
           }  
-        }
-        else   // 2nd order equation, 1st root of fSTheta cone, 2nd if 1st root -ve
-        {
-          if( std::fabs(distTheta) < flexRadMaxTolerance*0.5) // && t2 >= 0.) surface
-          {
-            if( fSTheta > halfpi && t2 >= 0. ) // leave
+        }      // 2nd order equation, 1st root of fSTheta cone,
+        else   // 2nd if 1st root -ve
+        {
+          if( std::fabs(distTheta) < halfRmaxTolerance )
+          {
+            if( (fSTheta > halfpi) && (t2 >= 0.) ) // leave
             {
               if( calcNorm ) 
@@ -2394,18 +2063,18 @@
                 if (rho2)
                 {
-                    rhoSecTheta = std::sqrt(rho2*(1+tanSTheta2));
+                  rhoSecTheta = std::sqrt(rho2*(1+tanSTheta2));
                    
-                    *n = G4ThreeVector( p.x()/rhoSecTheta,   
-                                        p.y()/rhoSecTheta,
-                                        std::sin(fSTheta)  );
+                  *n = G4ThreeVector( p.x()/rhoSecTheta,   
+                                      p.y()/rhoSecTheta,
+                                      std::sin(fSTheta)  );
                 }
-                else *n = G4ThreeVector(0.,0.,1.);
-              }                           
+                else  { *n = G4ThreeVector(0.,0.,1.); }
+              }
               return snxt = 0.;
             }
-            else if( fSTheta < halfpi  && t2 < 0. && p.z() >=0. ) // leave
-            {
-                if( calcNorm )   *validNorm = false;                                                 
-                return snxt = 0.;
+            else if( (fSTheta < halfpi) && (t2 < 0.) && (p.z() >=0.) ) // leave
+            {
+              if( calcNorm )  { *validNorm = false; }
+              return snxt = 0.;
             }                               
           }
@@ -2422,11 +2091,10 @@
               s = -b - d;         // First root
 
-              if( (std::fabs(s) < flexRadMaxTolerance*0.5 && t2 < 0.) ||
-                              s < 0.  ||
-                  ( s > 0. && p.z() + s*v.z() > 0.)                   ) 
+              if ( ((std::fabs(s) < halfRmaxTolerance) && (t2 < 0.))
+               ||  (s < 0.)  || ( (s > 0.) && (p.z() + s*v.z() > 0.) )     ) 
               {
                 s = -b + d ; // 2nd root
               }
-              if( s >  flexRadMaxTolerance*0.5 && p.z() + s*v.z() <= 0.)  
+              if( (s > halfRmaxTolerance) && (p.z() + s*v.z() <= 0.) )  
               {
                 stheta    = s;
@@ -2438,11 +2106,10 @@
               s = -b - d;         // First root
 
-              if( (std::fabs(s) < flexRadMaxTolerance*0.5 && t2 >= 0.) ||
-                              s < 0.                                   ||
-                  ( s > 0. && p.z() + s*v.z() < 0.)                      )
+              if ( ( (std::fabs(s) < halfRmaxTolerance) && (t2 >= 0.) )
+                || (s < 0.) || ( (s > 0.) && (p.z() + s*v.z() < 0.) )   )
               {
                 s = -b + d ; // 2nd root
               }
-              if( s >  flexRadMaxTolerance*0.5 && p.z() + s*v.z() >= 0.)  
+              if( (s > halfRmaxTolerance) && (p.z() + s*v.z() >= 0.) )  
               {
                 stheta    = s;
@@ -2454,14 +2121,11 @@
       }
     }
-    if (fSTheta + fDTheta < pi) // intersection with second cons
-    {
-
-      tanETheta = std::tan(fSTheta+fDTheta);
-
+    if (eTheta < pi) // intersection with second cons
+    {
       if( std::fabs(tanETheta) > 5./kAngTolerance ) // kons is plane z=0
       {
         if( v.z() < 0. ) 
         {
-          if ( std::fabs( p.z() ) <= flexRadMaxTolerance*0.5 )
+          if ( std::fabs( p.z() ) <= halfRmaxTolerance )
           {
             if(calcNorm)
@@ -2474,5 +2138,5 @@
           s = -p.z()/v.z();
 
-          if( s < stheta)
+          if( s < stheta )
           {
             stheta    = s;
@@ -2483,24 +2147,22 @@
       else // kons is not plane 
       {
-        tanETheta2  = tanETheta*tanETheta;
         t1          = 1-v.z()*v.z()*(1+tanETheta2);
         t2          = pDotV2d-p.z()*v.z()*tanETheta2;  // ~vDotN if p on cons
-        dist2ETheta = rho2-p.z()*p.z()*tanETheta2;      // t3
-
-        // distTheta = std::sqrt(std::fabs(dist2ETheta/(1+tanETheta2)));
+        dist2ETheta = rho2-p.z()*p.z()*tanETheta2;     // t3
+
         distTheta = std::sqrt(rho2)-p.z()*tanETheta;
 
-        if( std::fabs(t1) < 0.5*kAngTolerance ) // 1st order equation, v parallel to kons
-        {
+        if( std::fabs(t1) < halfAngTolerance ) // 1st order equation,
+        {                                      // v parallel to kons
           if( v.z() < 0. )
           {
-            if(std::fabs(distTheta) < flexRadMaxTolerance*0.5) // p on surface
-            {
-              if( fSTheta+fDTheta > halfpi && p.z() < 0. )
-              {
-                if( calcNorm ) *validNorm = false;
-                              return snxt = 0.;
-              }
-              else if( fSTheta+fDTheta < halfpi && p.z() >= 0)
+            if(std::fabs(distTheta) < halfRmaxTolerance) // p on surface
+            {
+              if( (eTheta > halfpi) && (p.z() < 0.) )
+              {
+                if( calcNorm )  { *validNorm = false; }
+                return snxt = 0.;
+              }
+              else if ( (eTheta < halfpi) && (p.z() >= 0) )
               {
                 if( calcNorm ) 
@@ -2510,10 +2172,9 @@
                   {
                     rhoSecTheta = std::sqrt(rho2*(1+tanETheta2));
-                   
                     *n = G4ThreeVector( p.x()/rhoSecTheta,   
                                         p.y()/rhoSecTheta,
-                                        -std::sin(fSTheta+fDTheta)  );
+                                        -sinETheta  );
                   }
-                  else *n = G4ThreeVector(0.,0.,-1.);
+                  else  { *n = G4ThreeVector(0.,0.,-1.); }
                 }
                 return snxt = 0.;               
@@ -2522,5 +2183,5 @@
             s = -0.5*dist2ETheta/t2;
 
-            if( s < stheta)
+            if( s < stheta )
             {
               stheta    = s;
@@ -2528,10 +2189,10 @@
             }
           }  
-        }
-        else   // 2nd order equation, 1st root of fSTheta cone, 2nd if 1st root -ve
-        {
-          if( std::fabs(distTheta) < flexRadMaxTolerance*0.5) // && t2 >= 0.) surface
-          {
-            if( fSTheta+fDTheta < halfpi && t2 >= 0. ) // leave
+        }      // 2nd order equation, 1st root of fSTheta cone
+        else   // 2nd if 1st root -ve
+        {
+          if ( std::fabs(distTheta) < halfRmaxTolerance )
+          {
+            if( (eTheta < halfpi) && (t2 >= 0.) ) // leave
             {
               if( calcNorm ) 
@@ -2541,8 +2202,7 @@
                 {
                     rhoSecTheta = std::sqrt(rho2*(1+tanETheta2));
-                   
                     *n = G4ThreeVector( p.x()/rhoSecTheta,   
                                         p.y()/rhoSecTheta,
-                                        -std::sin(fSTheta+fDTheta)  );
+                                        -sinETheta  );
                 }
                 else *n = G4ThreeVector(0.,0.,-1.);
@@ -2550,8 +2210,9 @@
               return snxt = 0.;
             }
-            else if( fSTheta+fDTheta > halfpi  && t2 < 0. && p.z() <=0. ) // leave
-            {
-                if( calcNorm )   *validNorm = false;                                                 
-                return snxt = 0.;
+            else if ( (eTheta > halfpi)
+                   && (t2 < 0.) && (p.z() <=0.) ) // leave
+            {
+              if( calcNorm )  { *validNorm = false; }
+              return snxt = 0.;
             }                               
           }
@@ -2564,14 +2225,14 @@
             d = std::sqrt(d2);
 
-            if( fSTheta+fDTheta < halfpi )
+            if( eTheta < halfpi )
             {
               s = -b - d;         // First root
 
-              if( (std::fabs(s) < flexRadMaxTolerance*0.5 && t2 < 0.) ||
-                              s < 0. ) 
+              if( ((std::fabs(s) < halfRmaxTolerance) && (t2 < 0.))
+               || (s < 0.) ) 
               {
                 s = -b + d ; // 2nd root
               }
-              if( s >  flexRadMaxTolerance*0.5 )  
+              if( s > halfRmaxTolerance )  
               {
                 if( s < stheta )
@@ -2586,11 +2247,10 @@
               s = -b - d;         // First root
 
-              if( (std::fabs(s) < flexRadMaxTolerance*0.5 && t2 >= 0.) ||
-                              s < 0.                                   ||
-                  ( s > 0. && p.z() + s*v.z() > 0.)                      )
+              if ( ((std::fabs(s) < halfRmaxTolerance) && (t2 >= 0.))
+                || (s < 0.) || ( (s > 0.) && (p.z() + s*v.z() > 0.) ) )
               {
                 s = -b + d ; // 2nd root
               }
-              if( s >  flexRadMaxTolerance*0.5 && p.z() + s*v.z() <= 0.)  
+              if( (s > halfRmaxTolerance) && (p.z() + s*v.z() <= 0.) )  
               {
                 if( s < stheta )
@@ -2610,16 +2270,7 @@
   // Phi Intersection
     
-  if ( fDPhi < twopi)
-  {
-    sinSPhi=std::sin(fSPhi);
-    cosSPhi=std::cos(fSPhi);
-    ePhi=fSPhi+fDPhi;
-    sinEPhi=std::sin(ePhi);
-    cosEPhi=std::cos(ePhi);
-    cPhi=fSPhi+fDPhi*0.5;
-    sinCPhi=std::sin(cPhi);
-    cosCPhi=std::cos(cPhi);
-
-    if ( p.x()||p.y() ) // Check if on z axis (rho not needed later)
+  if ( !fFullPhiSphere )
+  {
+    if ( p.x() || p.y() ) // Check if on z axis (rho not needed later)
     {
       // pDist -ve when inside
@@ -2634,5 +2285,5 @@
       sidephi = kNull ;
 
-      if ( pDistS <= 0 && pDistE <= 0 )
+      if ( (pDistS <= 0) && (pDistE <= 0) )
       {
         // Inside both phi *full* planes
@@ -2644,8 +2295,17 @@
           yi   = p.y()+sphi*v.y() ;
 
-          // Check intersecting with correct half-plane
-          // (if not -> no intersect)
-
-          if ( ( yi*cosCPhi - xi*sinCPhi ) >= 0 )
+          // Check intersection with correct half-plane (if not -> no intersect)
+          //
+          if( (std::abs(xi)<=kCarTolerance) && (std::abs(yi)<=kCarTolerance) )
+          {
+            vphi = std::atan2(v.y(),v.x());
+            sidephi = kSPhi;
+            if ( ( (fSPhi-halfAngTolerance) <= vphi)
+              && ( (ePhi+halfAngTolerance)  >= vphi) )
+            {
+              sphi = kInfinity;
+            }
+          }
+          else if ( ( yi*cosCPhi - xi*sinCPhi ) >= 0 )
           {
             sphi=kInfinity;
@@ -2654,8 +2314,8 @@
           {
             sidephi = kSPhi ;
-            if ( pDistS > -0.5*kCarTolerance) sphi =0 ; // Leave by sphi 
-          }
-        }
-        else sphi = kInfinity ;
+            if ( pDistS > -halfCarTolerance)  { sphi = 0; } // Leave by sphi 
+          }
+        }
+        else  { sphi = kInfinity; }
 
         if ( compE < 0 )
@@ -2667,10 +2327,24 @@
             yi = p.y()+sphi2*v.y() ;
 
-            // Check intersecting with correct half-plane
- 
-            if ((yi*cosCPhi-xi*sinCPhi)>=0) // Leaving via ending phi
+            // Check intersection with correct half-plane
+            //
+            if ((std::abs(xi)<=kCarTolerance) && (std::abs(yi)<=kCarTolerance))
+            {
+              // Leaving via ending phi
+              //
+              vphi = std::atan2(v.y(),v.x()) ;
+               
+              if( !((fSPhi-halfAngTolerance <= vphi)
+                  &&(fSPhi+fDPhi+halfAngTolerance >= vphi)) )
+              { 
+                sidephi = kEPhi;
+                if ( pDistE <= -halfCarTolerance )  { sphi = sphi2; }
+                else                                { sphi = 0.0;   }
+              }
+            }
+            else if ((yi*cosCPhi-xi*sinCPhi)>=0) // Leaving via ending phi
             {
               sidephi = kEPhi ;
-              if ( pDistE <= -0.5*kCarTolerance )
+              if ( pDistE <= -halfCarTolerance )
               {
                 sphi=sphi2;
@@ -2684,5 +2358,5 @@
         }        
       }
-      else if ( pDistS >= 0 && pDistE >= 0 ) // Outside both *full* phi planes
+      else if ((pDistS >= 0) && (pDistE >= 0)) // Outside both *full* phi planes
       {
         if ( pDistS <= pDistE )
@@ -2696,6 +2370,6 @@
         if ( fDPhi > pi )
         {
-          if ( compS < 0 && compE < 0 ) sphi = 0 ;
-          else                          sphi = kInfinity ;
+          if ( (compS < 0) && (compE < 0) )  { sphi = 0; }
+          else                               { sphi = kInfinity; }
         }
         else
@@ -2704,15 +2378,9 @@
           // will remain inside
 
-          if ( compS >= 0 && compE >= 0 )
-          {
-            sphi=kInfinity;
-          }
-          else
-          {
-            sphi=0;
-          }
+          if ( (compS >= 0) && (compE >= 0) ) { sphi = kInfinity; }
+          else                                { sphi = 0; }
         }    
       }
-      else if ( pDistS > 0 && pDistE < 0 )
+      else if ( (pDistS > 0) && (pDistE < 0) )
       {
         // Outside full starting plane, inside full ending plane
@@ -2729,5 +2397,15 @@
             // (if not -> not leaving phi extent)
             //
-            if ( ( yi*cosCPhi - xi*sinCPhi ) <= 0 )
+            if( (std::abs(xi)<=kCarTolerance)&&(std::abs(yi)<=kCarTolerance) )
+            {
+              vphi = std::atan2(v.y(),v.x());
+              sidephi = kSPhi;
+              if ( ( (fSPhi-halfAngTolerance) <= vphi)
+                && ( (ePhi+halfAngTolerance)  >= vphi) )
+              {
+                sphi = kInfinity;
+              }
+            }
+            else if ( ( yi*cosCPhi - xi*sinCPhi ) <= 0 )
             {
               sphi = kInfinity ;
@@ -2736,5 +2414,5 @@
             {
               sidephi = kEPhi ;
-              if ( pDistE > -0.5*kCarTolerance ) sphi = 0. ;
+              if ( pDistE > -halfCarTolerance )  { sphi = 0.; }
             }
           }
@@ -2757,5 +2435,15 @@
               // (if not -> remain in extent)
               //
-              if ( ( yi*cosCPhi - xi*sinCPhi) <= 0 )
+              if( (std::abs(xi)<=kCarTolerance)&&(std::abs(yi)<=kCarTolerance) )
+              {
+                vphi = std::atan2(v.y(),v.x());
+                sidephi = kSPhi;
+                if ( ( (fSPhi-halfAngTolerance) <= vphi)
+                  && ( (ePhi+halfAngTolerance)  >= vphi) )
+                {
+                  sphi = kInfinity;
+                }
+              }
+              else if ( ( yi*cosCPhi - xi*sinCPhi) <= 0 )
               {
                 sphi=kInfinity;
@@ -2787,16 +2475,26 @@
             xi=p.x()+sphi*v.x();
             yi=p.y()+sphi*v.y();
-
+            
             // Check intersection in correct half-plane
             // (if not -> not leaving phi extent)
             //
-            if ( ( yi*cosCPhi - xi*sinCPhi ) >= 0 )
+            if( (std::abs(xi)<=kCarTolerance)&&(std::abs(yi)<=kCarTolerance) )
+            {
+              vphi = std::atan2(v.y(),v.x()) ;
+              sidephi = kSPhi;
+              if ( ( (fSPhi-halfAngTolerance) <= vphi)
+                && ( (ePhi+halfAngTolerance)  >= vphi) )
+              {
+              sphi = kInfinity;
+              }
+            }
+            else if ( ( yi*cosCPhi - xi*sinCPhi ) >= 0 )
             {
               sphi = kInfinity ;
             }
-           else  // Leaving via Starting phi
-           {
+            else  // Leaving via Starting phi
+            {
               sidephi = kSPhi ;
-             if ( pDistS > -0.5*kCarTolerance ) sphi = 0 ;
+              if ( pDistS > -halfCarTolerance )  { sphi = 0; }
             }
           }
@@ -2815,9 +2513,19 @@
               xi   = p.x()+sphi*v.x() ;
               yi   = p.y()+sphi*v.y() ;
-
+              
               // Check intersection in correct half-plane
               // (if not -> remain in extent)
               //
-              if ( ( yi*cosCPhi - xi*sinCPhi ) >= 0 )
+              if((std::abs(xi)<=kCarTolerance) && (std::abs(yi)<=kCarTolerance))
+              {
+                vphi = std::atan2(v.y(),v.x()) ;
+                sidephi = kSPhi;
+                if ( ( (fSPhi-halfAngTolerance) <= vphi)
+                  && ( (ePhi+halfAngTolerance)  >= vphi) )
+                {
+                  sphi = kInfinity;
+                }
+              }
+              else if ( ( yi*cosCPhi - xi*sinCPhi ) >= 0 )
               {
                 sphi = kInfinity ;
@@ -2849,7 +2557,7 @@
       {
         vphi = std::atan2(v.y(),v.x()) ;
-        if ( fSPhi < vphi && vphi < fSPhi + fDPhi )
-        {
-          sphi=kInfinity;
+        if ((fSPhi-halfAngTolerance < vphi) && (vphi < ePhi+halfAngTolerance))
+        {
+          sphi = kInfinity;
         }
         else
@@ -2859,5 +2567,5 @@
         }
       }
-      else  // travel along z - no phi intersaction
+      else  // travel along z - no phi intersection
       {
         sphi = kInfinity ;
@@ -2895,8 +2603,8 @@
         if ( fDPhi <= pi )     // Normal to Phi-
         {
-          *n=G4ThreeVector(std::sin(fSPhi),-std::cos(fSPhi),0);
+          *n=G4ThreeVector(sinSPhi,-cosSPhi,0);
           *validNorm=true;
         }
-        else *validNorm=false;
+        else  { *validNorm=false; }
         break ;
 
@@ -2904,8 +2612,8 @@
         if ( fDPhi <= pi )      // Normal to Phi+
         {
-          *n=G4ThreeVector(-std::sin(fSPhi+fDPhi),std::cos(fSPhi+fDPhi),0);
+          *n=G4ThreeVector(-sinEPhi,cosEPhi,0);
           *validNorm=true;
         }
-        else *validNorm=false;
+        else  { *validNorm=false; }
         break;
 
@@ -2920,30 +2628,44 @@
           xi = p.x() + snxt*v.x();
           yi = p.y() + snxt*v.y();
-          rhoSecTheta = std::sqrt((xi*xi+yi*yi)*(1+tanSTheta2));
-          *n = G4ThreeVector( xi/rhoSecTheta,   // N-
-                              yi/rhoSecTheta,
-                              -tanSTheta/std::sqrt(1+tanSTheta2));
+          rho2=xi*xi+yi*yi;
+          if (rho2)
+          { 
+            rhoSecTheta = std::sqrt(rho2*(1+tanSTheta2));
+            *n = G4ThreeVector( xi/rhoSecTheta, yi/rhoSecTheta,
+                               -tanSTheta/std::sqrt(1+tanSTheta2));
+          }
+          else
+          {
+            *n = G4ThreeVector(0.,0.,1.);
+          }
           *validNorm=true;
         }
-        else *validNorm=false;  // Concave STheta cone
+        else  { *validNorm=false; }  // Concave STheta cone
         break;
 
       case kETheta:
-        if( ( fSTheta + fDTheta ) == halfpi )
+        if( eTheta == halfpi )
         {
           *n         = G4ThreeVector(0.,0.,-1.);
           *validNorm = true;
         }
-        else if ( ( fSTheta + fDTheta ) < halfpi)
+        else if ( eTheta < halfpi )
         {
           xi=p.x()+snxt*v.x();
           yi=p.y()+snxt*v.y();
-          rhoSecTheta = std::sqrt((xi*xi+yi*yi)*(1+tanETheta2));
-          *n = G4ThreeVector( xi/rhoSecTheta,   // N+
-                              yi/rhoSecTheta,
-                              -tanETheta/std::sqrt(1+tanETheta2) );
+          rho2=xi*xi+yi*yi;
+          if (rho2)
+          { 
+            rhoSecTheta = std::sqrt(rho2*(1+tanETheta2));
+            *n = G4ThreeVector( xi/rhoSecTheta, yi/rhoSecTheta,
+                               -tanETheta/std::sqrt(1+tanETheta2) );
+          }
+          else
+          {
+            *n = G4ThreeVector(0.,0.,-1.);
+          }
           *validNorm=true;
         }
-        else *validNorm=false;   // Concave ETheta cone
+        else  { *validNorm=false; }   // Concave ETheta cone
         break;
 
@@ -2995,14 +2717,13 @@
 /////////////////////////////////////////////////////////////////////////
 //
-// Calcluate distance (<=actual) to closest surface of shape from inside
+// Calculate distance (<=actual) to closest surface of shape from inside
 
 G4double G4Sphere::DistanceToOut( const G4ThreeVector& p ) const
 {
   G4double safe=0.0,safeRMin,safeRMax,safePhi,safeTheta;
-  G4double rho2,rad,rho;
-  G4double phiC,cosPhiC,sinPhiC,ePhi;
+  G4double rho2,rds,rho;
   G4double pTheta,dTheta1,dTheta2;
   rho2=p.x()*p.x()+p.y()*p.y();
-  rad=std::sqrt(rho2+p.z()*p.z());
+  rds=std::sqrt(rho2+p.z()*p.z());
   rho=std::sqrt(rho2);
 
@@ -3027,6 +2748,6 @@
   if (fRmin)
   {
-    safeRMin=rad-fRmin;
-    safeRMax=fRmax-rad;
+    safeRMin=rds-fRmin;
+    safeRMax=fRmax-rds;
     if (safeRMin<safeRMax)
     {
@@ -3040,5 +2761,5 @@
   else
   {
-    safe=fRmax-rad;
+    safe=fRmax-rds;
   }
 
@@ -3046,19 +2767,15 @@
   // Distance to phi extent
   //
-  if (fDPhi<twopi && rho)
-  {
-    phiC=fSPhi+fDPhi*0.5;
-    cosPhiC=std::cos(phiC);
-    sinPhiC=std::sin(phiC);
-    if ((p.y()*cosPhiC-p.x()*sinPhiC)<=0)
-    {
-      safePhi=-(p.x()*std::sin(fSPhi)-p.y()*std::cos(fSPhi));
+  if (!fFullPhiSphere && rho)
+  {
+    if ((p.y()*cosCPhi-p.x()*sinCPhi)<=0)
+    {
+      safePhi=-(p.x()*sinSPhi-p.y()*cosSPhi);
     }
     else
     {
-      ePhi=fSPhi+fDPhi;
-      safePhi=(p.x()*std::sin(ePhi)-p.y()*std::cos(ePhi));
-    }
-    if (safePhi<safe) safe=safePhi;
+      safePhi=(p.x()*sinEPhi-p.y()*cosEPhi);
+    }
+    if (safePhi<safe)  { safe=safePhi; }
   }
 
@@ -3066,30 +2783,17 @@
   // Distance to Theta extent
   //    
-  if (rad)
-  {
-    pTheta=std::acos(p.z()/rad);
-    if (pTheta<0) pTheta+=pi;
+  if (rds)
+  {
+    pTheta=std::acos(p.z()/rds);
+    if (pTheta<0)  { pTheta+=pi; }
     dTheta1=pTheta-fSTheta;
-    dTheta2=(fSTheta+fDTheta)-pTheta;
-    if (dTheta1<dTheta2)
-    {
-      safeTheta=rad*std::sin(dTheta1);
-      if (safe>safeTheta)
-      {
-        safe=safeTheta;
-      }
-    }
-    else
-    {
-      safeTheta=rad*std::sin(dTheta2);
-      if (safe>safeTheta)
-      {
-        safe=safeTheta;
-      }
-    }
-  }
-
-  if (safe<0) safe=0;
-    return safe;
+    dTheta2=eTheta-pTheta;
+    if (dTheta1<dTheta2)  { safeTheta=rds*std::sin(dTheta1); }
+    else                  { safeTheta=rds*std::sin(dTheta2); }
+    if (safe>safeTheta)   { safe=safeTheta; }
+  }
+
+  if (safe<0)  { safe=0; }
+  return safe;
 }
 
@@ -3119,5 +2823,5 @@
   // Phi cross sections
     
-  noPhiCrossSections=G4int (fDPhi/kMeshAngleDefault)+1;
+  noPhiCrossSections = G4int(fDPhi/kMeshAngleDefault)+1;
     
   if (noPhiCrossSections<kMinMeshSections)
@@ -3134,5 +2838,5 @@
   // on the x axis. Will give better extent calculations when not rotated.
     
-  if (fDPhi==pi*2.0 && fSPhi==0)
+  if (fFullPhiSphere)
   {
     sAnglePhi = -meshAnglePhi*0.5;
@@ -3160,5 +2864,5 @@
   // on the z axis. Will give better extent calculations when not rotated.
     
-  if (fDTheta==pi && fSTheta==0)
+  if (fFullThetaSphere)
   {
     startTheta = -meshTheta*0.5;
@@ -3223,6 +2927,6 @@
   }
 
-  delete[] cosCrossTheta;
-  delete[] sinCrossTheta;
+  delete [] cosCrossTheta;
+  delete [] sinCrossTheta;
 
   return vertices;
@@ -3269,30 +2973,28 @@
   G4double height1, height2, slant1, slant2, costheta, sintheta,theta,rRand;
 
-  height1 = (fRmax-fRmin)*std::cos(fSTheta);
-  height2 = (fRmax-fRmin)*std::cos(fSTheta+fDTheta);
-  slant1  = std::sqrt(sqr((fRmax - fRmin)*std::sin(fSTheta))
-                      + height1*height1);
-  slant2  = std::sqrt(sqr((fRmax - fRmin)*std::sin(fSTheta+fDTheta))
-                      + height2*height2);
+  height1 = (fRmax-fRmin)*cosSTheta;
+  height2 = (fRmax-fRmin)*cosETheta;
+  slant1  = std::sqrt(sqr((fRmax - fRmin)*sinSTheta) + height1*height1);
+  slant2  = std::sqrt(sqr((fRmax - fRmin)*sinETheta) + height2*height2);
   rRand   = RandFlat::shoot(fRmin,fRmax);
   
-  aOne = fRmax*fRmax*fDPhi*(std::cos(fSTheta)-std::cos(fSTheta+fDTheta));
-  aTwo = fRmin*fRmin*fDPhi*(std::cos(fSTheta)-std::cos(fSTheta+fDTheta));
-  aThr = fDPhi*((fRmax + fRmin)*std::sin(fSTheta))*slant1;
-  aFou = fDPhi*((fRmax + fRmin)*std::sin(fSTheta+fDTheta))*slant2;
+  aOne = fRmax*fRmax*fDPhi*(cosSTheta-cosETheta);
+  aTwo = fRmin*fRmin*fDPhi*(cosSTheta-cosETheta);
+  aThr = fDPhi*((fRmax + fRmin)*sinSTheta)*slant1;
+  aFou = fDPhi*((fRmax + fRmin)*sinETheta)*slant2;
   aFiv = 0.5*fDTheta*(fRmax*fRmax-fRmin*fRmin);
   
-  phi = RandFlat::shoot(fSPhi, fSPhi + fDPhi); 
+  phi = RandFlat::shoot(fSPhi, ePhi); 
   cosphi = std::cos(phi); 
   sinphi = std::sin(phi);
-  theta = RandFlat::shoot(fSTheta,fSTheta+fDTheta);
+  theta = RandFlat::shoot(fSTheta,eTheta);
   costheta = std::cos(theta);
   sintheta = std::sqrt(1.-sqr(costheta));
 
-  if( ((fSPhi==0) && (fDPhi==2.*pi)) || (fDPhi==2.*pi) ) {aFiv = 0;}
-  if(fSTheta == 0)  {aThr=0;}
-  if(fDTheta + fSTheta == pi) {aFou = 0;}
-  if(fSTheta == 0.5*pi) {aThr = pi*(fRmax*fRmax-fRmin*fRmin);}
-  if(fSTheta + fDTheta == 0.5*pi) { aFou = pi*(fRmax*fRmax-fRmin*fRmin);}
+  if(fFullPhiSphere) { aFiv = 0; }
+  if(fSTheta == 0)   { aThr=0; }
+  if(eTheta == pi) { aFou = 0; }
+  if(fSTheta == halfpi) { aThr = pi*(fRmax*fRmax-fRmin*fRmin); }
+  if(eTheta == halfpi)  { aFou = pi*(fRmax*fRmax-fRmin*fRmin); }
 
   chose = RandFlat::shoot(0.,aOne+aTwo+aThr+aFou+2.*aFiv);
@@ -3309,9 +3011,9 @@
   else if( (chose>=aOne+aTwo) && (chose<aOne+aTwo+aThr) )
   {
-    if (fSTheta != 0.5*pi)
-    {
-      zRand = RandFlat::shoot(fRmin*std::cos(fSTheta),fRmax*std::cos(fSTheta));
-      return G4ThreeVector(std::tan(fSTheta)*zRand*cosphi,
-                           std::tan(fSTheta)*zRand*sinphi,zRand);
+    if (fSTheta != halfpi)
+    {
+      zRand = RandFlat::shoot(fRmin*cosSTheta,fRmax*cosSTheta);
+      return G4ThreeVector(tanSTheta*zRand*cosphi,
+                           tanSTheta*zRand*sinphi,zRand);
     }
     else
@@ -3322,10 +3024,9 @@
   else if( (chose>=aOne+aTwo+aThr) && (chose<aOne+aTwo+aThr+aFou) )
   {
-    if(fSTheta + fDTheta != 0.5*pi)
-    {
-      zRand = RandFlat::shoot(fRmin*std::cos(fSTheta+fDTheta),
-                              fRmax*std::cos(fSTheta+fDTheta));
-      return G4ThreeVector  (std::tan(fSTheta+fDTheta)*zRand*cosphi,
-                             std::tan(fSTheta+fDTheta)*zRand*sinphi,zRand);
+    if(eTheta != halfpi)
+    {
+      zRand = RandFlat::shoot(fRmin*cosETheta, fRmax*cosETheta);
+      return G4ThreeVector  (tanETheta*zRand*cosphi,
+                             tanETheta*zRand*sinphi,zRand);
     }
     else
@@ -3336,12 +3037,59 @@
   else if( (chose>=aOne+aTwo+aThr+aFou) && (chose<aOne+aTwo+aThr+aFou+aFiv) )
   {
-    return G4ThreeVector(rRand*sintheta*std::cos(fSPhi),
-                         rRand*sintheta*std::sin(fSPhi),rRand*costheta);
+    return G4ThreeVector(rRand*sintheta*cosSPhi,
+                         rRand*sintheta*sinSPhi,rRand*costheta);
   }
   else
   {
-    return G4ThreeVector(rRand*sintheta*std::cos(fSPhi+fDPhi),
-                         rRand*sintheta*std::sin(fSPhi+fDPhi),rRand*costheta);
-  }
+    return G4ThreeVector(rRand*sintheta*cosEPhi,
+                         rRand*sintheta*sinEPhi,rRand*costheta);
+  }
+}
+
+////////////////////////////////////////////////////////////////////////////////
+//
+// GetSurfaceArea
+
+G4double G4Sphere::GetSurfaceArea()
+{
+  if(fSurfaceArea != 0.) {;}
+  else
+  {   
+    G4double Rsq=fRmax*fRmax;
+    G4double rsq=fRmin*fRmin;
+         
+    fSurfaceArea = fDPhi*(rsq+Rsq)*(cosSTheta - cosETheta);
+    if(!fFullPhiSphere)
+    {
+      fSurfaceArea = fSurfaceArea + fDTheta*(Rsq-rsq);
+    }
+    if(fSTheta >0)
+    {
+      G4double acos1=std::acos( std::pow(sinSTheta,2) * std::cos(fDPhi)
+                              + std::pow(cosSTheta,2));
+      if(fDPhi>pi)
+      { 
+        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*(twopi-acos1);
+      }
+      else
+      {
+        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*acos1;
+      }
+    }
+    if(eTheta < pi)
+    {
+      G4double acos2=std::acos( std::pow(sinETheta,2) * std::cos(fDPhi)
+                              + std::pow(cosETheta,2));
+      if(fDPhi>pi)
+      { 
+        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*(twopi-acos2);
+      }
+      else
+      {
+        fSurfaceArea = fSurfaceArea + 0.5*(Rsq-rsq)*acos2;
+      }
+    }
+  }
+  return fSurfaceArea;
 }
 
Index: trunk/source/geometry/solids/CSG/src/G4Torus.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Torus.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Torus.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Torus.cc,v 1.63 2007/10/02 09:34:17 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Torus.cc,v 1.65 2009/11/26 10:31:06 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -284,7 +284,16 @@
 
     G4double theta = std::atan2(ptmp.y(),ptmp.x());
-
-    if (theta < 0)  { theta += twopi; }
     
+    if ( fSPhi >= 0 )
+    {
+      if ( theta < - kAngTolerance*0.5 )  { theta += twopi; }
+      if ( (std::abs(theta) < kAngTolerance*0.5)
+        && (std::abs(fSPhi + fDPhi - twopi) < kAngTolerance*0.5) )
+      { 
+        theta += twopi ; // 0 <= theta < 2pi
+      }
+    }
+    if ((fSPhi <= -pi )&&(theta>kAngTolerance*0.5)) { theta = theta-twopi; }
+       
     // We have to verify if this root is inside the region between
     // fSPhi and fSPhi + fDPhi
Index: trunk/source/geometry/solids/CSG/src/G4Trap.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Trap.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Trap.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trap.cc,v 1.45 2008/04/23 09:49:57 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Trap
Index: trunk/source/geometry/solids/CSG/src/G4Trd.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Trd.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Trd.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trd.cc,v 1.34 2006/10/19 15:33:38 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
